//+------------------------------------------------------------------+
//|                                         Directional_Breakout.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_color4 Yellow

extern int Price=0;    // Applied price
                       // 0 - Close
                       // 1 - Open
                       // 2 - High
                       // 3 - Low
                       // 4 - Median
                       // 5 - Typical
                       // 6 - Weighted
extern int Method=0;  // 0 - SMA
                      // 1 - EMA
                      // 2 - SMMA
                      // 3 - LWMA
extern int Length=20;

double UPh[],UPl[], N1h[],N1l[];

int init()
{
 IndicatorShortName("Directional Breakout");
 IndicatorDigits(Digits);
 SetIndexStyle(0,DRAW_HISTOGRAM);
 SetIndexBuffer(0,UPh);
 SetIndexStyle(1,DRAW_HISTOGRAM);
 SetIndexBuffer(1,UPl);
 SetIndexStyle(2,DRAW_HISTOGRAM);
 SetIndexBuffer(2,N1h);
 SetIndexStyle(3,DRAW_HISTOGRAM);
 SetIndexBuffer(3,N1l);

 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
    int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   for(int pos=limit; pos>=0; pos--)
   {
      double MA=iMA(NULL, 0, Length, 0, Method, Price, pos);
         UPh[pos] = EMPTY_VALUE;
         UPl[pos] = EMPTY_VALUE;
         N1h[pos] = EMPTY_VALUE;
         N1l[pos] = EMPTY_VALUE;
  
         if (Low[pos]>MA)
         {
            UPh[pos]= High[pos];
            UPl[pos]= Low[pos];
         }
         else
         {
            if (High[pos]<MA)
            {
               UPl[pos]= High[pos];
               UPh[pos]= Low[pos];
            }
            else
            {
               N1h[pos]= High[pos];
               N1l[pos]= Low[pos];
            }
         }
   } 
   return(0);
}